//Make Quadratic Curve
//
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */
#define TRUE 1
#define FALSE 0

#define NumberControlPoints 53   //is prime
#define NbSteps 32   //nb of steps for interpolation
#define MinValue 0   //64*0.125
#define MaxValue 64 //2*64

/**** From D.E.Knuth's Art of Computer Programming, vol.2, p185 ****/
/**** period of pseudorandom sequence is 2147483646             ****/
#define rndM 2147483647 /* 2^31-1, a Mersenne prime */
#define rndA 48271      /* this does well in the spectral test */
#define rndQ 44488      /* rndM/rndA */
#define rndR 3399       /* rndM%rndA, it's important that rndR<rndQ */
long rndX=1;            /* should be initialised to 0<rndX<rndM */
void rndNext() {
  rndX=rndA*(rndX%rndQ)-rndR*(long)(rndX/rndQ); /* X=AX mod M */
  if(rndX<0) {rndX+=rndM; }
}          

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */

  int i,r,s;
  int y0,ym,y1,h1,hm,h0,a,b,c;
  int ControlPoint[NumberControlPoints];
  int Values[NumberControlPoints*NbSteps+200];
  // randomly choose control points in [MinValue;MaxValue]
  for(i=0;i<NumberControlPoints;i++) {
    do{
      rndNext();
      r=rndX%MaxValue;
    }while(r<MinValue);
    //!!!printf("%d ",r);
    ControlPoint[i]=r;
  }
  //!!!printf("\n");
  printf(" dc.w %d ;Number of values\n",NumberControlPoints*NbSteps);
  //quadratic interpolation
  for(i=0;i<NumberControlPoints;i++) {
    h0=ControlPoint[i];
    hm=ControlPoint[(i+1)%NumberControlPoints];
    h1=ControlPoint[(i+2)%NumberControlPoints];
    //printf("%d %d %d // ",h0,hm,h1);
    y0=(h0+hm)/2;
    ym=hm;
    y1=(hm+h1)/2;
    //coefficients for quadratic curve
    c=y0*NbSteps*NbSteps;
    b=2*(ym-y0)*NbSteps;
    a=y1-2*ym+y0;
    //
    for(s=0;s<NbSteps;s++) {
      Values[i*NbSteps+s]=(a*s*s+b*s+c)/(NbSteps*NbSteps);
      if(s==0) { printf(" dc.w "); }
      printf("%d",Values[i*NbSteps+s]);
      if(s!=NbSteps-1) { printf(","); } else { printf("\n"); }
    }
  }
  
  exit(0);
}
