//Make Sinus Curves

#include <stdio.h>  // file functions, etc...
#include <stdlib.h> // exit(), malloc()
#include <math.h>   // sin, etc...

#define TRUE 1
#define FALSE 0
#define pi 3.1415926535897932384626433832795

#define NbSin 1024  //Nb of Sinus Values, one word each
#define SinN  12    //Shift for values in Sinus table
#define NbSize 256
#define SizeN 8     //log2(Nb of values in TubeSizeCurves), one word each, must be <SinN

// returns 0 if n<0
int Power(int x,int n) {
  if(n>0) {
    return (x*Power(x,n-1));
  } else if ((n==0) && (x!=0)) {
    return (1);
  } else {
    return (0);
  }
}

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */

  int c,t;
  double angle,multiplier;
  
  //Sinus table
  printf("Sinus:");
  for(c=0;c<NbSin;c++) {
    if((c & 31)==0) { printf("\n dc.w "); }
    angle=((float) c)*2*pi/NbSin;
    t=(int) (Power(2,SinN)*sin(angle));
    printf("%d",t);
    if((c & 31)!=31) { printf(","); }
  }
  
  //TubeSizeCurves are sinus curves with a multiplier
  printf("\n\nTubeSizeCurves:");
  for(multiplier=-7.5;multiplier<=7.5;multiplier=multiplier+1.0) {
    for(c=0;c<NbSize;c++) {
    if((c & 31)==0) { printf("\n dc.w "); }
      angle=((float) c)*2*pi/NbSize;
      t=2048*((int) (7.5+multiplier*sin(angle)));
      printf("%d",t);
      if((c & 31)!=31) { printf(","); }
    }
  }
  exit(0);
}
